package  
{
	import com.greensock.TweenLite;
	import org.flixel.FlxG;
	import org.flixel.FlxText;
	/**
	 * ...
	 * @author Basile Desloges
	 */
	public class Message extends FlxText
	{
		private static var somethingIsDisplayed : Boolean = false;
		private static var currentMessage : FlxText;
		
		private var currentTime : Number;
		private var maxTime : Number;
		private var fadeOutTime : Number;
		private var deleting : Boolean;
		
		public static function newMessage(text : String, time : uint = 10, fadeOut : Number = 1) : void {
			if (somethingIsDisplayed) {
				currentMessage.kill();
			}
			
			currentMessage = new Message(text, time, fadeOut);
			currentMessage.scrollFactor.x = 0;
			currentMessage.scrollFactor.y = 0;
			FlxG.state.add(currentMessage);
			somethingIsDisplayed = true;
		}
		
		public function Message(text : String, time : uint = 10, fadeOut : Number = 1)
		{
			super(0, 5, FlxG.width, text);
			color = MenuState.textColor;
			alignment = "center";
			antialiasing = false;
			currentTime = 0;
			maxTime = time;
			fadeOutTime = fadeOut;
			deleting = false;
		}
		
		override public function update() : void {
			if ( !deleting ) {
				currentTime += FlxG.elapsed;
				if ( currentTime > maxTime ) {
					TweenLite.to(this, fadeOutTime, { alpha:0.0, onComplete:this.kill } );
					deleting = true;
				}
			}
			
			super.update();
		}
		
	}

}