package  
{
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	/**
	 * ...
	 * @author Basile Desloges
	 */
	public class Player extends FlxSprite
	{
		[Embed(source='../assets/player.png')]
		private var imgPlayer : Class;
		
		public function Player(x : Number = 0, y : Number = 0) 
		{
			super(x, y);
			loadGraphic(imgPlayer, true, false, 16, 16, true);
			
			addAnimation("standUp", [0]);
			addAnimation("up", [0, 1, 2, 3, 2, 1, 0, 4, 5, 6, 5, 4, 0], 20, true);
			
			addAnimation("standDown", [7]);
			addAnimation("down", [7, 8, 9, 10, 9, 8, 7, 11, 12, 13, 12, 11, 7], 20, true);
			
			addAnimation("standLeft", [14]);
			addAnimation("left", [14, 15, 16, 17, 16, 15, 14, 18, 19, 20, 19, 18, 14], 20, true);
			
			addAnimation("standRight", [21]);
			addAnimation("right", [21, 22, 23, 24, 23, 22, 21, 25, 26, 27, 26, 25, 21], 20, true);
		}
		
		override public function update() : void {
			var moved : Boolean = false;
			
			velocity.x = 0;
			velocity.y = 0;
			
			// Movement
			if (FlxG.keys.LEFT) {
				play("left");
				velocity.x = -50;
				facing = FlxSprite.LEFT;
				moved = true;
			}
			else if (FlxG.keys.RIGHT) {
				play("right");
				velocity.x = 50;
				facing = FlxSprite.RIGHT;
				moved = true;
			}
			
			if (FlxG.keys.UP) {
				if(!moved) play("up");
				velocity.y = -50;
				facing = FlxSprite.UP;
				moved = true;
			}
			else if (FlxG.keys.DOWN) {
				if(!moved) play("down");
				velocity.y = 50;
				facing = FlxSprite.DOWN;
				moved = true;
			}
			
			if ( !moved ) {
				if (facing == FlxSprite.UP) {
					play("standUp");
				}
				else if (facing == FlxSprite.DOWN) {
					play("standDown");
				}
				else if (facing == FlxSprite.LEFT) {
					play("standLeft");
				}
				else if (facing == FlxSprite.RIGHT) {
					play("standRight");
				}
			}
			
			super.update();
		}
	}

}